/*
    Sproit v1.1

    Andreas Finne <andreas@calc.org>
	July 27th 2002

    This program can (should) handle any-sized BMP pictures.
*/


#include <stdio.h>

FILE *ut,*in;

int GetInfo(int n)
{
  int tot=0,i;
  unsigned char b[4];
  fseek(in,n,SEEK_SET);
  fread(b,4,1,in);
  for(i=3;i>0;i--)
      tot=tot+((b[i]*i)<<8);
  tot=tot+b[0];
  return tot;
}

void binwrite(unsigned char num)
{
  int i;
  char str[9];
  for(i=7;i>-1;i--) {
      str[i]=(num % 2)+'0';
      num=num>>1;
  }
  str[8]=0;
  fprintf(ut,"%s",str);
}

void readline(int grp, int num, int width)
{
  unsigned char temp;
  int i=0,j=0;
  fseek(in,-(grp<<2),SEEK_CUR);
  fprintf(ut,".db ");
  while(j!=(grp<<2)) {
	  fread(&temp,1,1,in);
	  if(i<num) {
		  fprintf(ut,"%%");
		  temp=temp^255;
		  if(i==num-1 && width%8!=0)
			  binwrite(temp & (256-(1<<(8 - (width % 8)))));
		  else
			  binwrite(temp);
		  fprintf(ut,",");
	  }
	  i++;
	  j++;
  }

  fseek(ut,-1,SEEK_CUR);
  fprintf(ut,"\n");
  fseek(in,-(grp<<2),SEEK_CUR);
}

int main(int argc, char *argv[])
{
  int width,height,grprow,numbyte;
  printf("\nSproit v1.1 -- by Andreas Finne <andreas@calc.org>\n\n");
  if(argc<2) {
      printf("Usage: sproit <bmpfile> [outfile]\n\n");
	  printf(" Bmpfile is a monochrome bitmap file (1-bit)\n");
	  printf(" Outfile is where the .db statements will be placed\n");
	  printf(" If outfile isn't specified, sprite.txt is created\n");
      return 1;
  }
  in=fopen(argv[1],"rb");
  if(in==NULL) {
      printf("Can't open %s!\n",argv[1]);
      return 1;
  }
  if (argc==2)
	  ut=fopen("sprite.txt","w");
  else
      ut=fopen(argv[2],"w");
  if(ut==NULL) {
      printf("Can't create outfile!\n");
      return 1;
  }
  if(fgetc(in)!='B' || fgetc(in)!='M') {
      printf("Invalid file format!\n");
      return 1;
  }
  width=GetInfo(18);
  height=GetInfo(22);
  grprow = width>>5;
  if((width % 32)!=0)
    grprow++;
  numbyte = width>>3;
  if((width % 8)!=0)
    numbyte++;
  fseek(in,0,SEEK_END);
  fprintf(ut,";File created with Sproit v1.1 by Andreas Finne\n;Made from %s\n\n", argv[1]);
  while(height>0) {
      readline(grprow,numbyte,width);
      height--;
  }
  printf("Picture converted successfully.\n");
  return 0;
}
